<?php
/**
* HomepageterminvergabePlugin.class.php
*
* Plugin zum Verwalten von Terminbuchungen auf der Homepage
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2008 Jan Kulmann <jankul@zmml.uni-bremen.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+


$GLOBALS['sess']->register('open_cat');

require_once ("lib/functions.php");

class HomepageterminvergabePlugin extends AbstractStudIPHomepagePlugin {

	var $userid;
	var $username;
	var $open_cat;
	var $new_category_id;

	function HomepageterminvergabePlugin(){
		parent::AbstractStudIPHomepagePlugin();
		$this->setPluginIconName('images/termine.gif');
		$this->open_cat = & $GLOBALS['open_cat'];
		if (!is_array($this->open_cat)) $this->open_cat = array();
	}
	
	function setPluginpath($newpath){
		parent::setPluginpath($newpath);
		$this->buildMenu();
	}
	
	function buildMenu(){
		$tab = new PluginNavigation();
		$tab->setDisplayname(_("Terminvergabe"));
		$tab->setActive();
		$subnav = new PluginNavigation();
		$subnav->setDisplayname("Neue Termingruppe anlegen");
		$subnav->setActive();
		$subnav->setLinkParam("show_cat_form");
		$tab->addSubmenu($subnav);
		$subnav2 = new PluginNavigation();
		$subnav2->setDisplayname("Wo bin ich gebucht?");
		$subnav2->setActive();
		$subnav2->setLinkParam("show_bookings");
		$tab->addSubmenu($subnav2);
		$this->setNavigation($tab); 
	}

	function has_valid_entries($user_id) {
		$entries = array();
		$db = new DB_Seminar();
		$db->queryf("SELECT c.*, count(t.category_id) termine FROM tv_category c, tv_termine t WHERE c.visible=1 AND c.user_id='%s' AND t.category_id=c.category_id GROUP BY c.category_id",$user_id);
		while ($db->next_record()) {
			if ($db->f("seminar_id"))
				if (!$GLOBALS['perm']->have_studip_perm("autor",$db->f("seminar_id")))
					continue;
			array_push($entries, $db->f("category_id"));
		}
		return (count($entries) == 0 ? FALSE : TRUE);
	}

	function setRequestedUser($user) {
                parent::setRequestedUser($user);
                $u = $this->getRequestedUser();
                $this->setStatusShowOverviewPage($this->has_valid_entries($u->getUserId()));
        }

	function add_termin_to_calendar($termin_id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT t.*, c.titel c_titel FROM tv_termine t, tv_category c WHERE t.termin_id='%s' AND c.category_id=t.category_id",$termin_id);
		if ($db->next_record()) {
			$db2 = new DB_Seminar();
			$new_id = md5(uniqid(time()));
			$db2->queryf("INSERT INTO calendar_events (event_id, range_id, autor_id, uid, start, end, summary,
					class, category_intern, priority, location, ts, rtype, mkdate, chdate) 
					VALUES ('%s','%s','%s','%s',%d,%d,'%s','%s',%d,%d,'%s',UNIX_TIMESTAMP(),'%s',UNIX_TIMESTAMP(),UNIX_TIMESTAMP())",
					$new_id,
					$GLOBALS['auth']->auth['uid'],
					$GLOBALS['auth']->auth['uid'],
					'Stud.IP-'.$GLOBALS['auth']->auth['uid'].'@'.$termin_id,
					$db->f('von'),
					$db->f('bis'),
					$db->f('c_titel'),
					'PRIVATE',
					1,
					0,
					$db->f('ort'),
					'SINGLE'
					);
		}
	}

	function is_unique_entry($cat_id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT unique_entry FROM tv_category WHERE category_id='%s'",$cat_id);
		if ($db->next_record()) {
			return ($db->f("unique_entry") == 1 ? TRUE : FALSE);
		}
		return FALSE;
	}

	function is_already_booked($cat_id, $user_id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT t.termin_id FROM tv_termine t, tv_termine_user tu WHERE t.category_id='%s' AND tu.termin_id=t.termin_id AND tu.user_id='%s'",$cat_id, $user_id);
		return ($db->num_rows() == 0 ? FALSE : TRUE);
	}

	function show_category_form($cat_id=FALSE) {
		$db = new DB_Seminar();
		$c = array();
		if ($cat_id) {
			$db->queryf("SELECT * FROM tv_category WHERE category_id='%s'",$cat_id);
			$db->next_record();
			$c = $db->Record;
			$c['bemerkungen'] = htmlReady($c['bemerkungen']);
			$c['zusatz_text'] = htmlReady($c['zusatz_text']);
			$c['titel'] = htmlReady($c['titel']);
		}

		$vas = array();
		$db2 = new DB_Seminar();
		$db2->queryf("SELECT s.*, sem.name sem_name FROM seminare s, seminar_user su, semester_data sem WHERE s.Seminar_id=su.Seminar_id AND su.status='dozent' AND su.user_id='%s' AND s.start_time >= sem.beginn AND s.start_time <= sem.ende ORDER BY s.start_time DESC",$GLOBALS['auth']->auth['uid']);
		if ($db2->num_rows() > 0) {
			while ($db2->next_record()) 
				array_push($vas, $db2->Record);
		}

		include ('templates/category_form.tpl');
	}

	function get_registered_persons($termin_id) {
		$ret = array();
		$db = new DB_Seminar();
		$db->queryf("SELECT a.* FROM auth_user_md5 a, tv_termine_user t WHERE t.termin_id='%s' AND a.user_id=t.user_id",$termin_id);
		while ($db->next_record()) {
			array_push($ret, array("user_id"=>$db->f("user_id"),"username"=>$db->f("username"),"vorname"=>$db->f("Vorname"),"nachname"=>$db->f("Nachname")));
		}
		return $ret;
	}

	function show_booking_list($user_id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT t.termin_id, t.von, t.bis, t.ort, c.category_id, c.titel, c.user_id autor_id, c.enddate_admission FROM tv_termine_user tu, tv_termine t, tv_category c WHERE tu.user_id='%s' AND t.termin_id=tu.termin_id AND c.category_id=t.category_id ORDER BY t.von, t.bis, c.titel",$user_id);
		if ($db->num_rows() > 0) {
			$cssSw=new cssClassSwitcher;

			$t = array();
			while ($db->next_record()) {
				$cssSw->switchClass();
				$a = array();
				$a['class'] = $cssSw->getClass();
				$a['titel'] = $db->f("titel");
				$a['tag'] = date("d.m.Y",$db->f("von"));
				$a['von'] = date("H:i",$db->f("von"));
				$a['bis'] = date("H:i",$db->f("bis"));
				$a['ort'] = $db->f("ort");
				$a['iconlink'] = (!$db->f('enddate_admission') || time() < $db->f('enddate_admission') ?
						"<A HREF=\"".PluginEngine::getLink($this,array("modus"=>"unjoin","termin_id"=>$db->f("termin_id"),"plugin_subnavi_params"=>$_REQUEST['plugin_subnavi_params']))."\"><IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/logout_seminare.gif\" TITLE=\"austragen\" ALT=\"austragen\" BORDER=\"0\"></A>" :
						"<IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/closelock2.gif\" TITLE=\"Abmeldezeitraum abgelaufen\" ALT=\"Abmeldezeitraum abgelaufen\">"
						);
				$a['autorlink'] = "<A HREF=\"about.php?username=".get_username($db->f("autor_id"))."\">".get_fullname($db->f("autor_id"))."</A>";
				array_push($t, $a);
			}
			include('templates/booking_list.tpl');
		} else {
			echo "<TABLE BORDER=\"0\" STYLE=\"font-size:smaller;\">\n";
			parse_msg("infoF&uuml;r Sie liegen zur Zeit keine Buchungen vor.");
			echo "</TABLE>\n";
		}
		echo "<BR>";
	}

	function show_category_listing($user_id) {
		echo "<script type=\"text/javascript\" language=\"javascript\">\n";
		echo "function invert(k) {\n";
		echo "        for (var j = 0; j < document.forms['termine_'+k].elements.length; j++) {\n";
		echo "          if (document.forms['termine_'+k].elements[j].checked == true) {\n";
		echo "            document.forms['termine_'+k].elements[j].checked = false;\n";
		echo "          } else {\n";
		echo "            document.forms['termine_'+k].elements[j].checked = true;\n";
		echo "          }\n";
		echo "        }\n";
		echo "}\n";
		echo "</script>\n";

		$termin_heads = array("Tag","Uhrzeit","Ort","Anzahl<BR>Personen","Eingetragene Personen","&nbsp;","&nbsp;");
		$modus = trim($_REQUEST['modus']);
		$category_id = $_REQUEST['category_id'];
		$db = new DB_Seminar();
		$db2 = new DB_Seminar();
		$db->queryf("SELECT * FROM tv_category WHERE user_id='%s' ORDER BY titel",$user_id);
		if ($db->num_rows() > 0) {
			while ($db->next_record()) {
				if ($this->new_category_id == $db->f("category_id"))
					echo "<A NAME=\"cat_anker\" />\n";
				$opened = in_array($db->f("category_id"), $this->open_cat);
				$db2->queryf("SELECT * FROM tv_termine WHERE category_id='%s' ORDER BY von",$db->f("category_id"));
				echo "<TABLE BORDER=\"0\" WIDTH=\"100%\" CELLSPACING=\"0\" CELLPADDING=\"1\">\n";
				echo "  <TR CLASS=\"steel2\" STYLE=\"font-size:smaller; font-weight:bold;\">\n";
				echo "    <TD>\n";

				$link = PluginEngine::getLink($this,array("c_".($opened ? "close" : "open")=>$db->f("category_id")));
				$icon = "<IMG SRC=\"".$GLOBALS['ASSETS_URL']."images/termin-icon.gif\">";
				$tmp_titel=htmlReady(mila($db->f("titel")));
				$titel = "<A HREF=\"".$link."\"><FONT SIZE=\"-1\">".$tmp_titel."</FONT></A>";
				if ($db->f("visible")==0) $titel.="&nbsp;<SPAN STYLE=\"color:red;\">(unsichtbar f&uuml;r andere)</SPAN>";
				$count_termine = $db2->num_rows();
				$count_bookings = $this->get_number_of_bookings($db->f("category_id"));
				$zusatz = $count_termine." Termin".($count_termine != 1 ? "e" : "") . " / " . $count_bookings . " Buchung".($count_bookings != 1 ? "en" : "");

				echo "      <TABLE BORDER=\"0\" WIDTH=\"100%\" CELLPADDING=\"0\" CELLSPACING=\"0\">\n";
				echo "        <TR>\n";
				printhead ("100%", 0, $link, ($opened?"open":"close"), FALSE, $icon, $titel, $zusatz, time());
				echo "        <TR>\n";
				echo "      </TABLE>\n";

				echo "    </TD>\n";
				echo "  </TR>\n";
				if (in_array($db->f("category_id"), $this->open_cat)) {
					$cssSw=new cssClassSwitcher;
					$cssSw->hoverenabled = TRUE;
					echo "\n" . cssClassSwitcher::GetHoverJSFunction() . "\n";
					$db2->queryf("SELECT * FROM tv_termine WHERE category_id='%s' ORDER BY von",$db->f("category_id"));
					$zusatz = "";
					if ($db2->num_rows() > 0) $zusatz .= "<A HREF=\"".$this->getPluginpath()."/downloadmanager.php?category_id=".$db->f("category_id")."\">".makeButton("export","img")."</A>\n";
					$zusatz .= "<A HREF=\"".PluginEngine::getLink($this,array("modus"=>"show_cat_form","category_id"=>$db->f("category_id")))."\">".makeButton("bearbeiten","img")."</A>\n";
					$zusatz .= "<A HREF=\"".PluginEngine::getLink($this,array("modus"=>"show_add_termine","category_id"=>$db->f("category_id")))."#termin_form\">".makeButton("hinzufuegen","img")."</A>\n";
					$zusatz .= "<A HREF=\"".PluginEngine::getLink($this,array("modus"=>"delete_category","category_id"=>$db->f("category_id")))."\">".makeButton("loeschen","img")."</A>\n";
					echo "  <TR>\n";
					echo "    <TD ALIGN=\"center\" COLSPAN=\"2\">\n";
					if ($db->f("bemerkungen")) {
						echo "      <BLOCKQUOTE><BR>\n";
						echo "<DIV STYLE=\"text-align:left; font-size:smaller;\">".formatReady($db->f("bemerkungen"))."</DIV>";
						echo "      </BLOCKQUOTE>\n";
					}
					$hints = "";
					if ($this->is_unique_entry($db->f("category_id"))) {
						$hints .= "      <DIV STYLE=\"text-align:left;\"><TABLE STYLE=\"font-size:smaller;\" BORDER=\"0\"><TR><TD WIDTH=\"1%\"><IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/ausruf_small2.gif\"></TD><TD>In dieser Termingruppe ist nur ein einmaliges Anmelden erlaubt.</TD></TR></TABLE></DIV>\n";
					}
					if ($db->f("seminar_id")) {
						$obj = get_object_name($db->f("seminar_id"),"sem");
						$hints .= "      <DIV STYLE=\"text-align:left;\"><TABLE STYLE=\"font-size:smaller;\" BORDER=\"0\"><TR><TD WIDTH=\"1%\"><IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/ausruf_small2.gif\"></TD><TD>In diese Termingruppe k&ouml;nnen sich nur Teilnehmer der Veranstaltung <SPAN STYLE=\"color:green; font-weight:bold;\">".$obj['name']."</SPAN> eintragen.</TD></TR></TABLE></DIV>\n";
					}
					if ($db->f("enddate_admission")) {
						$hints .= "      <DIV STYLE=\"text-align:left;\"><TABLE STYLE=\"font-size:smaller;\" BORDER=\"0\"><TR><TD WIDTH=\"1%\"><IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/ausruf_small2.gif\"></TD><TD>An- und Abmeldungen sind nur bis zum <B>".date('d.m.Y',$db->f("enddate_admission"))."</B> um <B>".date('H:i:00',$db->f("enddate_admission"))."</B> Uhr m&ouml;glich.</TD></TR></TABLE></DIV>\n";
					}
					if ($db->f("zusatz_active") && $db->f("zusatz_mandatory")) {
						$hints .= "      <DIV STYLE=\"text-align:left;\"><TABLE STYLE=\"font-size:smaller;\" BORDER=\"0\"><TR><TD WIDTH=\"1%\"><IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/ausruf_small2.gif\"></TD><TD>Die Anmeldung zu Terminen in dieser Gruppe erfordert zwingend die Angabe von Zusatzinformationen!</TD></TR></TABLE></DIV>\n";
					}
					if ($hints) {
						echo "      <BLOCKQUOTE>\n";
						if ($db->f("bemerkungen")) echo "        <HR>\n"; else echo "        <BR>\n";
						echo $hints;
						echo "      </BLOCKQUOTE>\n";
					}
					echo "      <BLOCKQUOTE><BR>\n";
					if ($db2->num_rows() > 0) {
						
						echo "      <FORM NAME=\"termine_".$db->f("category_id")."\" METHOD=\"POST\" ACTION=\"".PluginEngine::getLink($this,array("modus"=>"multi_delete_termine"))."\">\n";
						echo "      <INPUT TYPE=\"hidden\" NAME=\"category_id\" VALUE=\"".$db->f("category_id")."\">\n";
						echo "      <TABLE BORDER=\"0\" WIDTH=\"95%\" STYLE=\"font-size:smaller;\" CELLSPACING=\"0\" CELLPADDING=\"1\">\n";
						echo "        <TR CLASS=\"blue_gradient\">\n";
						foreach ($termin_heads as $h)
							echo "          <TD STYLE=\"vertical-align:bottom; font-weight:bold;\">$h</TD>\n";
						echo "          <TD STYLE=\"text-align:center; font-size:smaller;\">Auswahl<BR>umkehren<BR><INPUT TYPE=\"checkbox\" onChange=\"invert('".$db->f("category_id")."');\"></TD>\n";
						echo "        </TR>\n";
						while ($db2->next_record()) {
							$cssSw->switchClass();
							$persons = $this->get_registered_persons($db2->f("termin_id"));
							echo "        <TR VALIGN=\"TOP\" CLASS=\"".$cssSw->getClass()."\">\n";
							echo "          <TD WIDTH=\"80\">".date('d.m.Y',$db2->f('von'))."</TD>\n";
							echo "          <TD WIDTH=\"100\">".date('H:i',$db2->f('von'))." - ".date('H:i',$db2->f('bis'))."</TD>\n";
							echo "          <TD WIDTH=\"200\">".(trim($db2->f('ort')) != "" ? formatReady($db2->f('ort')) : "&nbsp;")."</TD>\n";
							echo "          <TD WIDTH=\"80\">".formatReady($db2->f('anz_pers'))."</TD>\n";
							echo "          <TD>\n";
							if (count($persons) == 0) {
								echo "            <SPAN STYLE=\"font-style:italic; color:green\">unbelegt</SPAN>\n";
							} else {
								echo "            <OL START=1>\n";
								foreach ($persons as $p) {
									echo "            <LI><SPAN><A HREF=\"about.php?username=".$p['username']."\">".$p['vorname']." ".$p['nachname']." [".$p['username']."]</A>&nbsp;";
									echo "<A HREF=\"".PluginEngine::getLink($this,array("modus"=>"remove_admission","termin_id"=>$db2->f("termin_id"),"remove_username"=>$p['username']))."\"><IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/x_transparent.gif\" TITLE=\"Person austragen\" ALT=\"Person austragen\" BORDER=\"0\"></A></SPAN><BR>\n";
								}
								echo "            </OL>\n";
							}
							echo "          </TD>\n";
							echo "          <TD ALIGN=\"right\" WIDTH=\"5%\"><A HREF=\"".PluginEngine::getLink($this,array("modus"=>"edit_termin","termin_id"=>$db2->f("termin_id"), "category_id"=>$db->f("category_id")))."\">".makeButton("bearbeiten","img")."</A></TD>\n";
							echo "          <TD ALIGN=\"left\" WIDTH=\"5%\"><A HREF=\"".PluginEngine::getLink($this,array("modus"=>"delete_termin","termin_id"=>$db2->f("termin_id")))."\">".makeButton("loeschen","img")."</A></TD>\n";
							echo "          <TD ALIGN=\"center\" WIDTH=\"50\"><INPUT TYPE=\"checkbox\" VALUE=\"".$db2->f("termin_id")."\" NAME=\"del_termine[]\"></TD>\n";
							echo "        </TR>\n";
						}
						if (!($modus == "show_add_termine")) {
							echo "        <TR VALIGN=\"TOP\">\n";
							echo "          <TD COLSPAN=\"8\" ALIGN=\"right\"><INPUT TYPE=\"image\" ".makeButton("markierteloeschen","src")."></TD>\n";
							echo "        </TR>\n";
						}
						echo "      </TABLE>\n";
						echo "      </FORM>\n";
					} else echo "<SPAN STYLE=\"font-style:italic; font-size:smaller;\">Keine Termine vorhanden.</SPAN>\n";
					if ($modus == "show_add_termine" && $category_id == $db->f("category_id"))
						$this->show_termine_form($db->f("category_id"));
					echo "      </BLOCKQUOTE>\n";
					if (!($modus == "show_add_termine" && $category_id == $db->f("category_id"))) 
						echo "$zusatz<BR>";
					echo "    </TD>\n";
					echo "  </TR>\n";
				}
				echo "</TABLE>\n";
			}
		} else {
			echo "<TABLE>\n";
			parse_msg("infoSie haben noch keine Termingruppen angelegt.");
			echo "</TABLE>\n";
		}
	}

	function show_public_termine($user_id) {
		$u = new StudIPUser();
		$u = $this->getRequestedUser();
		$this->userid = $u->getUserId();
		$this->username = $u->getUsername();
		$open = $_REQUEST['t_open'];

		$termin_heads = array("Tag","Uhrzeit","Ort");
		$cssSw=new cssClassSwitcher;
		$cssSw->hoverenabled = TRUE;
		echo "\n" . cssClassSwitcher::GetHoverJSFunction() . "\n";
		$db = new DB_Seminar();
		$db2 = new DB_Seminar();
		$db->queryf("SELECT * FROM tv_category WHERE user_id='%s' AND visible=1 ORDER BY titel",$user_id);
		if ($db->num_rows() > 0) {
			echo "<CENTER>\n";
			echo "<TABLE BORDER=\"0\" WIDTH=\"85%\" CELLSPACING=\"0\" CELLPADDING=\"1\">\n";
			while ($db->next_record()) {

				if ($db->f("seminar_id"))
					if (!$GLOBALS['perm']->have_studip_perm("autor",$db->f("seminar_id")))
						continue;

				$db2->queryf("SELECT * FROM tv_termine WHERE category_id='%s' AND visible=1 AND bis>UNIX_TIMESTAMP() ORDER BY von",$db->f("category_id"));
				if ($db2->num_rows() == 0 ) continue;
				$link = $GLOBALS['PHP_SELF']."?username=".$this->username;
				$icon = "<IMG SRC=\"".$GLOBALS['ASSETS_URL']."images/termin-icon.gif\">";
				$tmp_titel=htmlReady(mila($db->f("titel")));
				$zusatz = "<A HREF=\"about.php?username=".get_username($db->f("user_id"))."\">".get_fullname($db->f("user_id"))."</A>";
				$titel = "<A HREF=\"".$link."&t_open=".($open==$db->f("category_id")?"":$db->f("category_id"))."#t_anker\"><FONT SIZE=\"-1\">".$tmp_titel."</FONT></A>";

				echo "  <TR>\n";
				echo "    <TD>\n";
				echo "      <TABLE BORDER=\"0\" WIDTH=\"100%\" CELLPADDING=\"0\" CELLSPACING=\"0\">\n";
				echo "        <TR>\n";
				printhead ("100%", 0, $link, ($open==$db->f("category_id")?"open":"close"), FALSE, $icon, $titel, $zusatz, time());
				echo "        <TR>\n";
				echo "      </TABLE>\n";
				echo "    </TD>\n";
				echo "  </TR>\n";
				if ($open == $db->f("category_id")) {
					if ($db2->num_rows() > 0) {
						echo "  <TR>\n";
						echo "    <TD ALIGN=\"left\">\n";
						if ($db->f("bemerkungen")) {
							echo "      <BLOCKQUOTE><BR>\n";
							echo "<DIV STYLE=\"text-align:left; font-size:smaller;\">".formatReady($db->f("bemerkungen"))."</DIV>";
							echo "      </BLOCKQUOTE>\n";
						}
						echo "      <BLOCKQUOTE><BR>\n";
						$hints = "";
						if ($this->is_unique_entry($db->f("category_id"))) {
							$hints .= "      <DIV STYLE=\"text-align:left;\"><TABLE STYLE=\"font-size:smaller;\" BORDER=\"0\"><TR><TD WIDTH=\"1%\"><IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/ausruf_small2.gif\"></TD><TD>In dieser Termingruppe ist nur ein einmaliges Anmelden erlaubt.</TD></TR></TABLE></DIV>\n";
						}
						if ($db->f("seminar_id")) {
							$obj = get_object_name($db->f("seminar_id"),"sem");
							$hints .= "      <DIV STYLE=\"text-align:left;\"><TABLE STYLE=\"font-size:smaller;\" BORDER=\"0\"><TR><TD WIDTH=\"1%\"><IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/ausruf_small2.gif\"></TD><TD>Es k&ouml;nnen sich nur Teilnehmer der Veranstaltung <SPAN STYLE=\"color:green; font-weight:bold;\">".$obj['name']."</SPAN> eintragen.</TD></TR></TABLE></DIV>\n";
						}
						if ($db->f("enddate_admission")) {
							$hints .= "      <DIV STYLE=\"text-align:left;\"><TABLE STYLE=\"font-size:smaller;\" BORDER=\"0\"><TR><TD WIDTH=\"1%\"><IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/ausruf_small2.gif\"></TD><TD>An- und Abmeldungen sind nur bis zum <B>".date('d.m.Y',$db->f("enddate_admission"))."</B> um <B>".date('H:i:00',$db->f("enddate_admission"))."</B> Uhr m&ouml;glich.</TD></TR></TABLE></DIV>\n";
						}
						if ($db->f("zusatz_active") && $db->f("zusatz_mandatory")) {
							$hints .= "      <DIV STYLE=\"text-align:left;\"><TABLE STYLE=\"font-size:smaller;\" BORDER=\"0\"><TR><TD WIDTH=\"1%\"><IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/ausruf_small2.gif\"></TD><TD>Die Anmeldung zu Terminen in dieser Gruppe erfordert zwingend die Angabe von Zusatzinformationen!</TD></TR></TABLE></DIV>\n";
						}
						if ($hints) {
							echo "      <BLOCKQUOTE>\n";
							if ($db->f("bemerkungen")) echo "        <HR>\n";
							echo $hints;
							echo "      </BLOCKQUOTE>\n";
						}
						echo "      <TABLE BORDER=\"0\" WIDTH=\"95%\" STYLE=\"font-size:smaller;\" CELLSPACING=\"0\" CELLPADDING=\"2\">\n";
						echo "        <TR CLASS=\"blue_gradient\">\n";
						foreach ($termin_heads as $h)
							echo "          <TD STYLE=\"font-weight:bold;\">$h</TD>\n";
						if ($db->f('zusatz_active'))
							echo "          <TD STYLE=\"font-weight:bold;\">".htmlReady($db->f('zusatz_text'))." ".($db->f('zusatz_mandatory') ? "<SPAN STYLE=\"color:red;\">(bitte angeben!)</SPAN>" : "")."</TD>\n";
						else
							echo "          <TD STYLE=\"font-weight:bold;\">&nbsp;</TD>\n";
						echo "        </TR>\n";
						while ($db2->next_record()) {
							$cssSw->switchClass();
							$persons = $this->get_registered_persons($db2->f("termin_id"));
							echo "        <TR CLASS=\"".$cssSw->getClass()."\">\n";
							echo "          <TD VALIGN=\"TOP\" WIDTH=\"10%\">".date('d.m.Y',$db2->f('von'))."</TD>\n";
							echo "          <TD VALIGN=\"TOP\" WIDTH=\"20%\">".date('H:i',$db2->f('von'))." - ".date('H:i',$db2->f('bis'))."</TD>\n";
							echo "          <TD VALIGN=\"TOP\" WIDTH=\"30%\">".($db2->f('ort') ? formatReady($db2->f('ort')) : "<SPAN STYLE=\"font-style:italic;\">nicht angegeben</SPAN>")."</TD>\n";
							echo "          <TD VALIGN=\"TOP\" ALIGN=\"right\" WIDTH=\"40%\">\n";
							if (!$db->f('enddate_admission') || time() < $db->f('enddate_admission')) {
								if (!$this->has_joined($db2->f("termin_id"))) 
									if (!$this->max_persons_reached($db2->f("termin_id")) && 
										((!$this->is_already_booked($db->f("category_id"),$GLOBALS['auth']->auth['uid']) && $this->is_unique_entry($db->f("category_id"))) || !$this->is_unique_entry($db->f("category_id"))))
										if ($db->f('zusatz_active')) {
											echo "            <FORM NAME=\"join_".$db2->f("termin_id")."\" METHOD=\"POST\" ACTION=\"".$GLOBALS['PHP_SELF']."?username=".$this->username."#t_anker\">\n";
											echo "              <TABLE BORDER=\"0\" STYLE=\"font-size:smaller; width:100%;\">\n";
											echo "                <TR>\n";
											echo "                  <TD ALIGN=\"left\" VALIGN=\"bottom\">\n";
											echo "                    <INPUT TYPE=\"text\" STYLE=\"width:200px;\" NAME=\"zusatz\">\n";
											echo "                    <INPUT TYPE=\"hidden\" NAME=\"termin_id\" VALUE=\"".$db2->f("termin_id")."\">\n";
											echo "                    <INPUT TYPE=\"hidden\" NAME=\"t_open\" VALUE=\"".$db->f("category_id")."\">\n";
											echo "                    <INPUT TYPE=\"hidden\" NAME=\"modus\" VALUE=\"join\">\n";
											echo "                  </TD><TD ALIGN=\"left\" VALIGN=\"bottom\">\n";
											echo "                    <INPUT TYPE=\"image\" ".makeButton("eintragen","src").">";
											echo "                  </TD>\n";
											echo "                </TR>\n";
											echo "              </TABLE>\n";
											echo "            </FORM>";
										} else
											echo "            <A HREF=\"".$GLOBALS['PHP_SELF']."?username=".$this->username."&modus=join&termin_id=".$db2->f("termin_id")."&t_open=".$db->f("category_id")."#t_anker\">".makeButton("eintragen","img")."</A>\n";
									else
										echo "<IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/x_transparent.gif\" TITLE=\"Keine Eintragung m&ouml;glich!\" ALT=\"Keine Eintragung m&ouml;glich!\">\n";
								else {
									echo "<A HREF=\"".$GLOBALS['PHP_SELF']."?username=".$this->username."&modus=unjoin&termin_id=".$db2->f("termin_id")."&t_open=".$db->f("category_id")."#t_anker\"><IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/logout_seminare.gif\" TITLE=\"Austragen\" ALT=\"Austragen\" BORDER=\"0\"></A>\n";
								}
							} else {
								echo "<IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/closelock2.gif\" TITLE=\"Abmeldezeitraum abgelaufen\" ALT=\"Abmeldezeitraum abgelaufen\">\n";
							}
	
							echo "          </TD>\n";
							echo "        </TR>\n";
						}
						echo "      </TABLE>\n";
						echo "      </BLOCKQUOTE>\n";
						echo "    </TD>\n";
						echo "  </TR>\n";
					}
				}
			}
			echo "</TABLE>\n";
			echo "</CENTER>\n";
		}
	}


	function show_termine_form($category_id) {
		include('templates/termine_form.tpl');
	}

	function generate_termine($category_id) {
		if ($_REQUEST['bis_m'] == "" && $_REQUEST['bis_t'] == "" && $_REQUEST['bis_j'] == "") {
			$_REQUEST['bis_m'] = $_REQUEST['von_m'];
			$_REQUEST['bis_t'] = $_REQUEST['von_t'];
			$_REQUEST['bis_j'] = $_REQUEST['von_j'];
		}

		$tag_von  = mktime(0, 0, 0, $_REQUEST['von_m'], $_REQUEST['von_t'], $_REQUEST['von_j']);
		$tag_bis  = mktime(0, 0, 0, $_REQUEST['bis_m'], $_REQUEST['bis_t'], $_REQUEST['bis_j']);
		$zeit_von = mktime($_REQUEST['von_h'], $_REQUEST['von_i']);
		$zeit_bis = mktime($_REQUEST['bis_h'], $_REQUEST['bis_i']);
		$turnus   = $_REQUEST['turnus'];
		$rahmen   = $_REQUEST['rahmen'];
		$zeitraum = $_REQUEST['zeitraum'];

		$rahmen_sek = $rahmen * 60;
		$zeitraum_sek = $zeitraum * 60;

		$von_t = $_REQUEST['von_t'];
		$von_m = $_REQUEST['von_m'];
		$von_j = $_REQUEST['von_j'];
		$von_h = $_REQUEST['von_h'];
		$von_i = $_REQUEST['von_i'];

		$bis_t = $_REQUEST['bis_t'];
		$bis_m = $_REQUEST['bis_m'];
		$bis_j = $_REQUEST['bis_j'];
		$bis_h = $_REQUEST['bis_h'];
		$bis_i = $_REQUEST['bis_i'];

		$tagessekunden_von = $von_h * 60 * 60 + $von_i * 60;
		$tagessekunden_bis = $bis_h * 60 * 60 + $bis_i * 60;

		/*
		//Debug
		echo "<SPAN STYLE=\"font-size:x-small;\">\n";
		echo "von_t=".$_REQUEST['von_t']."<BR>\n";
		echo "von_m=".$_REQUEST['von_m']."<BR>\n";
		echo "von_j=".$_REQUEST['von_j']."<BR>\n";
		echo "von_h=".$_REQUEST['von_h']."<BR>\n";
		echo "von_i=".$_REQUEST['von_i']."<BR>\n";
		echo "bis_t=".$_REQUEST['bis_t']."<BR>\n";
		echo "bis_m=".$_REQUEST['bis_m']."<BR>\n";
		echo "bis_j=".$_REQUEST['bis_j']."<BR>\n";
		echo "bis_h=".$_REQUEST['bis_h']."<BR>\n";
		echo "bis_i=".$_REQUEST['bis_i']."<BR>\n";
		echo "turnus=$turnus<BR>\n";
		echo "rahmen=$rahmen<BR>\n";
		echo "zeitraum=$zeitraum<BR>\n";
		echo "tag_von=".$tag_von." (".date("d.m.Y",$tag_von).")<BR>\n";
		echo "tag_bis=".$tag_bis." (".date("d.m.Y",$tag_bis).")<BR>\n";
		echo "zeit_von=".$zeit_von." (".date("H:i",$zeit_von).")<BR>\n";
		echo "zeit_bis=".$zeit_bis." (".date("H:i",$zeit_bis).")<BR>\n";
		echo "</SPAN><BR>\n";
		*/

		$termine = array();

		if ($tag_von > 0 && $tagessekunden_von < $tagessekunden_bis) {
			$start_zeit = mktime($von_h, $von_i, 0, date('m',$tag_von), date('d',$tag_von), date('Y',$tag_von));
			// Nur ein Tag..., turnus kann ignoriert werden
			if ($tag_bis < 0) {
				$end_zeit = mktime($bis_h, $bis_i, 0, date('m',$tag_von), date('d',$tag_von), date('Y',$tag_von));
				if ($start_zeit < $end_zeit) {
					$zeitpunkt = $start_zeit;
					$t = 0;
					while ($zeitpunkt <= $end_zeit) {
						//echo date("d.m.Y - H:i",$zeitpunkt);
						$zeitpunkt_bis = $zeitpunkt + $rahmen_sek;
						//echo " bis ".date("d.m.Y - H:i",$zeitpunkt_bis)."<BR>\n";

						array_push($termine, array($zeitpunkt, $zeitpunkt_bis));

						$zeitpunkt += $rahmen_sek + $zeitraum_sek;
						$t++;
						if ($t==100) exit;
					}
				}
			} else {
				// Termine ueber mehrere Tage
				$end_zeit = mktime($bis_h, $bis_i, 0, date('m',$tag_bis), date('d',$tag_bis), date('Y',$tag_bis));
				if ($start_zeit < $end_zeit) {
					$zeitpunkt = $start_zeit;
					$t = 0;
					while ($zeitpunkt <= $end_zeit) {
						//echo date("d.m.Y - H:i",$zeitpunkt);
						$zeitpunkt_bis = $zeitpunkt + $rahmen_sek;
						//echo " bis ".date("d.m.Y - H:i",$zeitpunkt_bis)."<BR>\n";

						// Sind wir bei einem Wochenendetag gelandet?
						if (!($turnus == 2 && (date('D',$zeitpunkt) == 'Sat' || date('D',$zeitpunkt) == 'Sun')))
							// Ueberschreitet der Termin die maximale Zeitangabe?
							if ($zeitpunkt_bis <= mktime($bis_h,$bis_i,0,date('m',$zeitpunkt_bis), date('d',$zeitpunkt_bis), date('Y',$zeitpunkt_bis)))
								array_push($termine, array($zeitpunkt, $zeitpunkt_bis));

						$zeitpunkt += $rahmen_sek + $zeitraum_sek;
						$t_zp = mktime($bis_h, $bis_i, 0, date('m',$zeitpunkt),date('d',$zeitpunkt), date('Y',$zeitpunkt));
						if ($turnus == 1 || $turnus == 2) { // taeglich
							if ($zeitpunkt > $t_zp) { // wenn der zp nach der max-Urhzeit liegt, fange bei nchstem Tag wieder an.
								$zeitpunkt = mktime($von_h, $von_i, 0, date('m',$zeitpunkt), date('d',$zeitpunkt) + 1, date('Y',$zeitpunkt));
							}
						}
						if ($turnus == 7 || $turnus == 14) { // woechentlich / zwei-woechentlich
							if ($zeitpunkt > $t_zp) { // wenn der zp nach der max-Urhzeit liegt, fange bei nchster Woche wieder an.
								$zeitpunkt = mktime($von_h, $von_i, 0, date('m',$zeitpunkt), date('d',$zeitpunkt) + $turnus, date('Y',$zeitpunkt));
							}
						}
						$t++;
						if ($t==10000) {
							// Bei zu vielen Terminen oder einer unwahrscheinlichen Endlosschleife, Ergebnisse rausgeben
							return $termine;
						}
					}
				}
			}
		}
		return $termine;
	}
	
	function show_create_termine($termine, $category_id) {
		// wurden korrekte Termien generiert?
		if (count($termine) > 0) {
			$cssSw=new cssClassSwitcher;
			foreach ($termine as &$t) {
				$cssSw->switchClass();
				$t['class'] = $cssSw->getClass();
				$t['von'] = $t[0];
				$t['bis'] = $t[1];
				$t['von_txt'] = date("d.m.Y - H:i", $t[0]);
				$t['bis_txt'] = date("H:i", $t[1]);
				$t['ort'] = htmlReady($_REQUEST['ort']);
				$t['anz_pers'] = htmlReady($_REQUEST['anz_pers']);
			}
			echo "<CENTER>\n";
			echo "    <TABLE BORDER=\"0\">\n";
			parse_msg("info".sprintf(_("Die angezeigten <B>%d Termine</B> werden im n&auml;chsten Schritt angelegt. Sie k&ouml;nnen hier Details ver&auml;ndern oder Termine ausschlie&szlig;en."),count($termine)));
			echo "    </TABLE>\n";
			include('templates/create_termine.tpl');
			echo "</CENTER>\n";
		}
	}

	function show_termin_edit_form($termin_id, $category_id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT * FROM tv_termine WHERE termin_id='%s'",$termin_id);
		$db->next_record();
		$t = $db->Record;
		$t['von_d'] = date('d',$t['von']);
		$t['von_m'] = date('m',$t['von']);
		$t['von_y'] = date('Y',$t['von']);
		$t['von_h'] = date('H',$t['von']);
		$t['von_i'] = date('i',$t['von']);
		$t['bis_h'] = date('H',$t['bis']);
		$t['bis_i'] = date('i',$t['bis']);

		include('templates/termin_edit_form.tpl');
	}


	function get_owser_of_category($category_id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT user_id FROM tv_category WHERE category_id='%s'",$category_id);
		if ($db->next_record())
			return $db->f('user_id');
		else
			return FALSE;
	}

	function add_myself_to_termin($termin_id, $zusatz) {
		$db = new DB_Seminar();
		$db->queryf("SELECT * FROM tv_termine_user WHERE termin_id='%s' AND user_id='%s'",$termin_id, $GLOBALS['auth']->auth['uid']);
		if (!$db->next_record()) {
			$db->queryf("INSERT INTO tv_termine_user (termin_id, user_id, zusatz) VALUES ('%s', '%s', '%s')", $termin_id, $GLOBALS['auth']->auth['uid'], mysql_real_escape_string($zusatz));
			$this->add_termin_to_calendar($termin_id);
		}
	}

	function remove_person_from_termin($termin_id, $pers_id) {
		$db = new DB_Seminar();
		$db->queryf("DELETE FROM tv_termine_user WHERE termin_id='%s' AND user_id='%s'",$termin_id, $pers_id);
		$db->queryf("DELETE FROM calendar_events WHERE autor_id='%s' AND range_id='%s' AND uid='%s'",
			$pers_id,
			$pers_id,
			'Stud.IP-'.$pers_id.'@'.$termin_id);
	}

	function has_joined($termin_id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT * FROM tv_termine_user WHERE termin_id='%s' AND user_id='%s'",$termin_id, $GLOBALS['auth']->auth['uid']);
		if ($db->next_record())
			return TRUE;
		else
			return FALSE;	
	}

	function max_persons_reached($termin_id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT t.termin_id, t.anz_pers, COUNT(u.user_id) user_count FROM tv_termine t, tv_termine_user u WHERE t.termin_id='%s' AND u.termin_id=t.termin_id GROUP BY t.termin_id",$termin_id);
		if ($db->next_record()) {
			if ($db->f("anz_pers") > $db->f("user_count"))
				return FALSE;
			else
				return TRUE;
		}
		return FALSE;
	}

	function get_number_of_bookings($category_id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT tu.user_id FROM tv_termine t, tv_termine_user tu WHERE t.category_id='%s' AND tu.termin_id=t.termin_id",$category_id);
		return $db->num_rows();
	}

	function show() {
		$this->showAdministrationPage();
	}

	function actionShowAdministrationPage() {
		$this->showAdministrationPage();
	}

	function showAdministrationPage(){
		$db = new DB_Seminar();
		$db2 = new DB_Seminar();
		$u = new StudIPUser();
		$u = $this->getRequestedUser();
		$this->userid = $u->getUserId();
		$this->username = $u->getUsername();
		$modus = trim($_REQUEST['modus']);
		$category_id = trim($_REQUEST['category_id']);

		$close = trim($_REQUEST['c_close']);
		$open  = trim($_REQUEST['c_open']);
		if ($close && is_array($this->open_cat)) {
			$tmp_arr = array();
                        foreach ($this->open_cat as $v)
                                if ($v != $close)
		                        array_push($tmp_arr, $v);
                        $this->open_cat = $tmp_arr;
                }
                if ($open && !in_array($open, $this->open_cat)) array_push($this->open_cat, $open);


		if ($this->userid == $GLOBALS['auth']->auth['uid'] || $GLOBALS['perm']->have_perm('root')) {
			$msg = "";
			if ($modus == "show_cat_form" || $GLOBALS['plugin_subnavi_params'] == "show_cat_form") {
				$this->show_category_form($category_id);
			}
			if ($modus == "show_add_termine") {
				unset($modus);
			}
			if ($modus == "edit_termin") {
				if ($_REQUEST['termin_id']) {
					$db->queryf("SELECT * FROM tv_termine WHERE termin_id='%s' AND user_id='%s'",$_REQUEST['termin_id'],$GLOBALS['auth']->auth['uid']);
					if ($db->next_record() || $GLOBALS['perm']->have_perm('root')) {
						$this->show_termin_edit_form($_REQUEST['termin_id'], $category_id);
					}
				}
			}
			if ($modus == "save_category") {
				$unique_entry = ($_REQUEST['unique_entry'] == 1 ? 1 : 0);
				$zusatz_active = ($_REQUEST['zusatz_active'] == 'yes' ? 1 : 0);
				$zusatz_mandatory = ($_REQUEST['zusatz_mandatory'] == 'yes' ? 1 : 0);
				$zusatz = trim($_REQUEST['zusatz']);
				$ende = 0;
				if ($_REQUEST['end_t'] && $_REQUEST['end_m'] && $_REQUEST['end_j'] && $_REQUEST['end_h'] && $_REQUEST['end_i'])
					$ende = mktime($_REQUEST['end_h'], $_REQUEST['end_i'], 0, $_REQUEST['end_m'], $_REQUEST['end_t'], $_REQUEST['end_j']);
				if ($category_id) {
					if (trim($_REQUEST['cat_name']))
						$db->queryf("UPDATE tv_category SET unique_entry=%d, titel='%s', bemerkungen='%s', visible=%d, seminar_id='%s', enddate_admission=%d, zusatz_active=%d, zusatz_text='%s', zusatz_mandatory=%d WHERE user_id='%s' AND category_id='%s'",$unique_entry,mysql_real_escape_string(trim($_REQUEST['cat_name'])),mysql_real_escape_string(trim($_REQUEST['cat_desc'])), $_REQUEST['visible'], $_REQUEST['seminar_id'], $ende, $zusatz_active, mysql_real_escape_string($zusatz), $zusatz_mandatory, $this->userid, $category_id);
				} else {
					$new_id = md5(uniqid(time()));
					if (trim($_REQUEST['cat_name']))
						$db->queryf("INSERT INTO tv_category (category_id, user_id, titel, bemerkungen, visible, unique_entry, seminar_id, enddate_admission, zusatz_active, zusatz_text, zusatz_mandatory) VALUES ('%s','%s','%s','%s', %d, %d, '%s', %d, %d, '%s', %d)",$new_id,$GLOBALS['auth']->auth['uid'],mysql_real_escape_string(trim($_REQUEST['cat_name'])),mysql_real_escape_string(trim($_REQUEST['cat_desc'])), $_REQUEST['visible'], $unique_entry, $_REQUEST['seminar_id'], $ende, $zusatz_active, mysql_real_escape_string($zusatz), $zusatz_mandatory);
					$this->new_category_id = $new_id;
					if (!in_array($this->new_category_id, $this->open_cat)) array_push($this->open_cat, $this->new_category_id);
				}
				$msg .= "msg"._("Die Termingruppe wurde gespeichert.");
				unset($modus);
			}
			if ($modus == "create_termine") {
				$this->show_create_termine($this->generate_termine($category_id), $category_id);
			}
			if ($modus == "create_termine_really") {
				$von = $_REQUEST['von'];
				$bis = $_REQUEST['bis'];
				$ort = $_REQUEST['ort'];
				$anz_pers = $_REQUEST['anz_pers'];
				$create = $_REQUEST['create'];
				if (is_array($von) && is_array($bis) && is_array($ort) && is_array($anz_pers) && is_array($create) && 
						($this->get_owser_of_category($category_id)==$GLOBALS['auth']->auth['uid'] || $GLOBALS['perm']->have_perm('root'))) {
					for ($i=0; $i<count($create); $i++) {
						if ($create[$i] == "yes") {
							$new_id = md5(uniqid(time()));
							$db->queryf("INSERT INTO tv_termine (termin_id, category_id, user_id, von, bis, ort, visible, anz_pers) VALUES ('%s','%s','%s',%d,%d,'%s',1,%d)",$new_id, $category_id, $GLOBALS['auth']->auth['uid'], $von[$i], $bis[$i], mysql_real_escape_string(trim($ort[$i])), $anz_pers[$i]);
						}
					}
				}
				unset($modus);
			}
			if ($modus == "save_termin") {
				$von = mktime($_REQUEST['von_h'],$_REQUEST['von_i'],0,$_REQUEST['von_m'],$_REQUEST['von_t'],$_REQUEST['von_j']);
				$bis = mktime($_REQUEST['bis_h'],$_REQUEST['bis_i'],0,$_REQUEST['von_m'],$_REQUEST['von_t'],$_REQUEST['von_j']);
				$db->queryf("SELECT * FROM tv_termine WHERE termin_id='%s' AND user_id='%s'",$_REQUEST['termin_id'],$GLOBALS['auth']->auth['uid']);
                                if ($db->next_record() || $GLOBALS['perm']->have_perm('root')) {
					$db->queryf("UPDATE tv_termine SET von=%d, bis=%d, ort='%s', anz_pers=%d WHERE termin_id='%s'",$von, $bis, mysql_real_escape_string(trim($_REQUEST['ort'])), $_REQUEST['anz_pers'], $_REQUEST['termin_id']);
					$msg .= "msg"._("Der Termin wurde aktualisiert.");
				}
				unset($modus);
			}
			if ($modus == "delete_termin") {
				echo "<TABLE BORDER=\"0\">\n";
				echo "  <TR>\n";
				echo "    <TD WIDTH=\"1%\" VALIGN=\"TOP\">\n";
				echo "      <IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/ausruf.gif\">\n";
				echo "    </TD><TD VALIGN=\"TOP\">\n";
				echo "      Soll der Termin wirklich gel&ouml;scht werden?<BR>\n";
				echo "      <A HREF=\"".PluginEngine::getLink($this,array("modus"=>"delete_termin_really","termin_id"=>$_REQUEST['termin_id']))."\"><IMG ".makeButton("ja","src")." BORDER=\"0\"></A>\n";
				echo "      <A HREF=\"".PluginEngine::getLink($this,array())."\"><IMG ".makeButton("nein","src")." BORDER=\"0\"></A>\n";
				echo "    </TD>\n";
				echo "  <TR>\n";
				echo "<TABLE>\n";
				unset($modus);
			}
			if ($modus == "delete_termin_really") {
				$termin_id = trim($_REQUEST['termin_id']);
				$db->queryf("SELECT c.*, t.von, t.bis FROM tv_category c, tv_termine t WHERE t.termin_id='%s' AND c.category_id=t.category_id",$termin_id);
				if ($db->next_record()) {
					$m = new messaging;
					$message = sprintf("Der Termin (%s am %s, %s Uhr) wurde von dem Eigentuemer (%s) bzw. einem Administrator geloescht.\n\n",$db->f('titel'),date('d.m.Y',$db->f('von')),(date('H:i',$db->f('von')).' - '.date('H:i',$db->f('bis'))),get_fullname($db->f('user_id')));
					if ($db->f('user_id') == $GLOBALS['auth']->auth['uid'] || $GLOBALS['perm']->have_perm('root')) {
						$db2->queryf("SELECT user_id FROM tv_termine_user WHERE termin_id='%s'",$termin_id);
						while ($db2->next_record())
							$m->insert_message($message, get_username($db2->f('user_id')), "____%system%____", FALSE, FALSE, 1, FALSE, _("Termin geloescht"));
						$db2->queryf("DELETE FROM tv_termine_user WHERE termin_id='%s'",$termin_id);
						$db2->queryf("DELETE FROM tv_termine WHERE termin_id='%s'",$termin_id);
					}
				}
				$msg .= "msg"._("Der Termin wurde gel&ouml;scht!");
				unset($modus);
			}
			if ($modus == "multi_delete_termine") {
				$termine = $_REQUEST['del_termine'];
				if (is_array($termine)) {
					echo "<FORM NAME=\"multidelete\" METHOD=\"POST\" ACTION=\"".PluginEngine::getLink($this,array("modus"=>"multi_delete_termine_really"))."\">\n";
                                        echo "<INPUT TYPE=\"hidden\" NAME=\"category_id\" VALUE=\"".$category_id."\">\n";
					foreach ($termine as $t)
						echo "<INPUT TYPE=\"hidden\" NAME=\"del_termine[]\" VALUE=\"".$t."\">\n";
					echo "<TABLE BORDER=\"0\">\n";
					echo "  <TR>\n";
					echo "    <TD WIDTH=\"1%\" VALIGN=\"TOP\">\n";
					echo "      <IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/ausruf.gif\">\n";
					echo "    </TD><TD VALIGN=\"TOP\">\n";
					echo "      Sollen die gew&auml;hlten <B>".count($termine)." Termine</B> wirklich gel&ouml;scht werden?<BR>\n";
					echo "      <TABLE BORDER=\"0\"><TR>\n";
					echo "        <TD><INPUT TYPE=\"image\" ".makeButton("ja","src")."></TD>\n";
					echo "        <TD><A HREF=\"".PluginEngine::getLink($this,array())."\"><IMG ".makeButton("nein","src")." BORDER=\"0\"></A></TD>\n";
					echo "      </TR></TABLE>\n";
					echo "    </TD>\n";
					echo "  <TR>\n";
					echo "<TABLE>\n";
					echo "</FORM>\n";
				}
				unset($modus);
			}
			if ($modus == "multi_delete_termine_really") {
				$termine = $_REQUEST['del_termine'];
				if (is_array($termine)) {
					$m = new messaging;
					foreach ($termine as $termin_id) {
						$db->queryf("SELECT c.*, t.von, t.bis FROM tv_category c, tv_termine t WHERE t.termin_id='%s' AND c.category_id=t.category_id",$termin_id);
						if ($db->next_record()) {
							if ($db->f('user_id') == $GLOBALS['auth']->auth['uid'] || $GLOBALS['perm']->have_perm('root')) {
								$message = sprintf("Der Termin (%s am %s, %s Uhr) wurde von dem Eigentuemer (%s) bzw. einem Administrator geloescht.\n\n",$db->f('titel'),date('d.m.Y',$db->f('von')),(date('H:i',$db->f('von')).' - '.date('H:i',$db->f('bis'))),get_fullname($db->f('user_id')));
								$db2->queryf("SELECT user_id FROM tv_termine_user WHERE termin_id='%s'",$termin_id);
								while ($db2->next_record())
									$m->insert_message($message, get_username($db2->f('user_id')), "____%system%____", FALSE, FALSE, 1, FALSE, _("Termin geloescht"));
								$db2->queryf("DELETE FROM tv_termine_user WHERE termin_id='%s'",$termin_id);
								$db2->queryf("DELETE FROM tv_termine WHERE termin_id='%s'",$termin_id);
							}
						}
					}
				}
				$msg .= "msg"._("Die gew&auml;hlten Termine wurden gel&ouml;scht!");
				unset($modus);
			}
			if ($modus == "delete_category") {
				echo "<TABLE BORDER=\"0\">\n";
				echo "  <TR>\n";
				echo "    <TD WIDTH=\"1%\" VALIGN=\"TOP\">\n";
				echo "      <IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/ausruf.gif\">\n";
				echo "    </TD><TD VALIGN=\"TOP\">\n";
				echo "      Soll die Termingruppe mit allen Termineintr&auml;gen und Buchungen wirklich gel&ouml;scht werden?<BR>\n";
				echo "      <A HREF=\"".PluginEngine::getLink($this,array("modus"=>"delete_category_really","category_id"=>$category_id))."\"><IMG ".makeButton("ja","src")." BORDER=\"0\"></A>\n";
				echo "      <A HREF=\"".PluginEngine::getLink($this,array())."\"><IMG ".makeButton("nein","src")." BORDER=\"0\"></A>\n";
				echo "    </TD>\n";
				echo "  <TR>\n";
				echo "<TABLE>\n";
			}
			if ($modus == "delete_category_really") {
				if ($this->get_owser_of_category($category_id)==$GLOBALS['auth']->auth['uid'] || $GLOBALS['perm']->have_perm('root')) {
					$db->queryf("SELECT * FROM tv_termine WHERE category_id='%s'",$category_id);
					while ($db->next_record()) {
						$db2->queryf("DELETE FROM tv_termine_user WHERE termin_id='%s'",$db2->f("termin_id"));
					}
					$db->queryf("DELETE FROM tv_termine WHERE category_id='%s'",$category_id);
					$db->queryf("DELETE FROM tv_category WHERE category_id='%s'",$category_id);
				}
				unset($modus);
			}
			if ($modus == "unjoin" && $this->has_joined($_REQUEST['termin_id'])) {
				$db->queryf("SELECT c.* FROM tv_category c, tv_termine t WHERE t.termin_id='%s' AND c.category_id=t.category_id",$_REQUEST['termin_id']);
				if ($db->next_record()) {
					if (!$db->f('enddate_admission') || time() < $db->f('enddate_admission')) {
						$this->remove_person_from_termin($_REQUEST['termin_id'],$GLOBALS['auth']->auth['uid']);
						$msg .= "msg"._("Sie haben sich erfolgreich ausgetragen!");
					} else {
						$msg .= "error"._("Sie k&ouml;nnen sich nicht austragen, der Abmeldezeitraum ist abgelaufen!");
					}
				}
				unset($modus);
			}
			if ($modus == "remove_admission" && $_REQUEST['termin_id'] && $_REQUEST['remove_username']) {
				$db->queryf("SELECT c.*, t.von, t.bis FROM tv_category c, tv_termine t WHERE t.termin_id='%s' AND c.category_id=t.category_id",$_REQUEST['termin_id']);
				if ($db->next_record()) {
					if ($db->f("user_id") == $GLOBALS['auth']->auth['uid'] || $GLOBALS['perm']->have_perm('root')) {
						// Gehoert der Termin uebrhaupt zu meinen oder bin ich ein Root?
						$user_id = get_userid($_REQUEST['remove_username']);
						if ($user_id) {
							$this->remove_person_from_termin($_REQUEST['termin_id'],$user_id);
							$msg .= "msg"._("Die Person wurde ausgetragen und dar&uuml;ber benachrichtigt!");
							$m = new messaging;
							$message = sprintf("Sie wurden von dem Eigentuemer (%s) bzw. einem Administrator aus einem Termin (%s am %s, %s Uhr) ausgetragen!\n\n",get_fullname($db->f('user_id')),$db->f('titel'),date('d.m.Y',$db->f('von')),(date('H:i',$db->f('von')).' - '.date('H:i',$db->f('bis'))));
							$m->insert_message($message, $_REQUEST['remove_username'], "____%system%____", FALSE, FALSE, 1, FALSE, _("Termineintrag geloescht"));
						}
					}
				}
				unset($modus);
			}
	
			if ($msg) {
				echo "<TABLE BORDER=\"0\" WIDTH=\"100%\" CELLSPACING=0 CELLPADDING=0>\n";
				parse_msg($msg);
				echo "</TABLE>\n";
			}

			if (!$modus && !$GLOBALS['plugin_subnavi_params']) {
				$this->show_category_listing($this->userid);
			}
			if (!$modus && $GLOBALS['plugin_subnavi_params'] == "show_bookings") {
				$this->show_booking_list($this->userid);
			}
		} else {
			echo "Zugriff verweigert!";
		}
	}

	function showOverview() {
		$modus = trim($_REQUEST['modus']);
		$u = new StudIPUser();
		$u = $this->getRequestedUser();
		$this->userid = $u->getUserId();
		$this->username = $u->getUsername();
		$category_id = $_REQUEST['t_open'];
		
		$msg = "";

		echo "<A NAME=\"t_anker\" />\n";

		if ($modus == "join" && !$this->has_joined($_REQUEST['termin_id']) && 
			!$this->max_persons_reached($_REQUEST['termin_id']) &&
                        ((!$this->is_already_booked($category_id,$GLOBALS['auth']->auth['uid']) && $this->is_unique_entry($category_id)) || !$this->is_unique_entry($category_id))
		) {
			$db = new DB_Seminar();
			$db->queryf("SELECT c.* FROM tv_category c, tv_termine t WHERE c.category_id=t.category_id AND t.termin_id='%s'",$_REQUEST['termin_id']);
			$db->next_record();
			if ($db->f("zusatz_active") && $db->f("zusatz_mandatory") && trim($_REQUEST['zusatz']) == "") {
				$msg .= "error"._("Sie m&uuml;ssen die Zusatzangaben ausf&uuml;llen, um sich zu diesem Termin anmelden zu k&ouml;nnen!");
			} else {
				$this->add_myself_to_termin($_REQUEST['termin_id'], trim($_REQUEST['zusatz']));
				$msg .= "msg"._("Sie haben sich zu diesem Termin eingetragen! Der Termin wurde au&szlig;erdem in Ihren pers&ouml;nlichen Terminkalender eingetragen.");
			}
			unset($modus);
		}
		if ($modus == "unjoin" && $this->has_joined($_REQUEST['termin_id'])) {
			$db = new DB_Seminar();
			$db->queryf("SELECT c.* FROM tv_category c, tv_termine t WHERE t.termin_id='%s' AND c.category_id=t.category_id",$_REQUEST['termin_id']);
			if ($db->next_record()) {
				if (!$db->f('enddate_admission') || time() < $db->f('enddate_admission')) {
					$this->remove_person_from_termin($_REQUEST['termin_id'],$GLOBALS['auth']->auth['uid']);
					$msg .= "msg"._("Sie haben sich erfolgreich ausgetragen!");
				} else {
					$msg .= "error"._("Sie k&ouml;nnen sich nicht austragen, der Abmeldezeitraum ist abgelaufen!");
				}
			}
			unset($modus);
		}

		if ($msg) {
			echo "<TABLE BORDER=\"0\" WIDTH=\"100%\" CELLSPACING=0 CELLPADDING=0>\n";
			parse_msg($msg);
			echo "</TABLE>\n";
		}

		$this->show_public_termine($this->userid);
		
	}

}

?>
